package nccloud.pubimpl.gl.account;

import java.util.ArrayList;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.logging.Logger;
import nc.vo.fi.uforeport.IUFOInvokeContext;
import nc.vo.gl.glreport.publictool.FunctionVO;
import nc.vo.gl.glreporttools.FormulaSepTool;
import nc.vo.gl.glreporttools.FuncitonVOTools;
import nc.vo.gl.glreporttools.FunctionType;
import nc.vo.gl.glreporttools.GroupVOContainer;
import nc.vo.gl.glreporttools.GroupVOContainerTool;
import nc.vo.gl.glreporttools.GroupVOTool;
import nc.vo.gl.glreporttools.PrepareParameterForReport;
import nc.vo.gl.glreporttools.TransferEnvVO;
import nc.vo.pub.lang.UFBoolean;

public class UfoGroupFunctionTool {

   public static String getFamulaKey(String strTempFormula) {
      if(strTempFormula == null) {
         return null;
      } else {
         FunctionVO tempFunvo = null;

         try {
            tempFunvo = getFunctionVO((String)strTempFormula);
            return tempFunvo.getKey();
         } catch (Exception var3) {
            Logger.error(var3.getMessage(), var3);
            return null;
         }
      }
   }

   public static GroupVOContainer[] getGroupContainerForLinkGL(String[] functions) throws Exception {
      GroupVOContainer[] containers = null;

      try {
         FunctionVO[] e = getFunctionVO((String[])functions);
         containers = GroupVOTool.getVOContainer(e);
         return containers;
      } catch (Exception var3) {
         Logger.error(var3.getMessage(), var3);
         throw var3;
      }
   }

   public static FunctionVO[] getFunctionsByKey(String key, GroupVOContainer[] containers) {
      if(key != null && containers != null && containers.length != 0) {
         Object[] oVOs = GroupVOContainerTool.getValueByKey(key, containers);
         if(oVOs != null && oVOs.length != 0) {
            FunctionVO[] funcvos = new FunctionVO[oVOs.length];

            for(int i = 0; i < oVOs.length; ++i) {
               funcvos[i] = (FunctionVO)oVOs[i];
            }

            return funcvos;
         } else {
            return null;
         }
      } else {
         return null;
      }
   }

   public static String getKeyFromFunction(String function) throws Exception {
      if(function != null && function.trim().length() != 0) {
         FunctionVO funcvo = getFunctionVO((String)function);
         return funcvo.getKey();
      } else {
         return null;
      }
   }

   public static String[] getKeyFromFunctions(String function) throws Exception {
      String[] pks = null;
      if(function != null && function.trim().length() != 0) {
         FunctionVO[] funcvos = getFunctionVOS(function);
         pks = new String[funcvos.length];

         for(int i = 0; i < funcvos.length; ++i) {
            pks[i] = funcvos[i].getKey();
         }

         return pks;
      } else {
         return null;
      }
   }

   public static FunctionVO getFunctionVO(String function) throws Exception {
      if(function != null && function.trim().length() != 0) {
         FunctionVO funvo = null;
         String funName = FormulaSepTool.getFunname(function);
         String param = FormulaSepTool.getParam(function);
         funvo = FuncitonVOTools.getFunctionVOs(funName, param);

         try {
            PrepareParameterForReport.prepareParasForReport(funvo, getDefaultEnv());
            return funvo;
         } catch (Exception var5) {
            Logger.error(var5.getMessage(), var5);
            throw var5;
         }
      } else {
         return null;
      }
   }

   public static TransferEnvVO getDefaultEnv() {
      Logger.info(" 进入方法getDefaultEnv（）调用");
      TransferEnvVO envvo = new TransferEnvVO();
      if(IUFOInvokeContext.getInstance().getCorporation() != null) {
         envvo.setPk_org(IUFOInvokeContext.getInstance().getCorporation().getPk_org());
      }

      envvo.setPk_group(InvocationInfoProxy.getInstance().getGroupId());
      Logger.info("年度" + IUFOInvokeContext.getInstance().getAccountYear());
      Logger.info("期间" + IUFOInvokeContext.getInstance().getAccountMonth());
      envvo.setAccYear(IUFOInvokeContext.getInstance().getAccountYear());
      envvo.setAccMouth(IUFOInvokeContext.getInstance().getAccountMonth());
      envvo.setPk_operator(InvocationInfoProxy.getInstance().getUserId());
      envvo.setPk_currtype("本币");
      envvo.setRetCurrtype("本币");
      envvo.setDate(IUFOInvokeContext.getInstance().getDate());
      envvo.setUntallied(UFBoolean.FALSE);
      Logger.info(" 方法getDefaultEnv（）调用结束");
      return envvo;
   }

   public static FunctionVO[] getFunctionVOS(String function) throws Exception {
      if(function != null && function.trim().length() != 0) {
         FunctionVO[] funvos = null;
         String funName = FormulaSepTool.getFunname(function);
         String param = FormulaSepTool.getParam(function);
         if(!FunctionType.isMultiOrgs(funName, param) && !FunctionType.isSubOrgs(funName, param)) {
            funvos = new FunctionVO[]{FuncitonVOTools.getFunctionVOs(funName, param)};
         } else {
            String[][] e = FormulaSepTool.getSepFunctions(funName, param);
            funvos = new FunctionVO[e.length];

            for(int i = 0; i < funvos.length; ++i) {
               funvos[i] = FuncitonVOTools.getFunctionVOs(e[i][0], e[i][1]);
            }
         }

         try {
            for(int var7 = 0; var7 < funvos.length; ++var7) {
               PrepareParameterForReport.prepareParasForReport(funvos[var7], getDefaultEnv());
            }

            return funvos;
         } catch (Exception var6) {
            Logger.error(var6.getMessage(), var6);
            throw var6;
         }
      } else {
         return null;
      }
   }

   public static FunctionVO[] getFunctionVO(String[] functions) throws Exception {
      if(functions != null && functions.length != 0) {
         FunctionVO[] funvos = null;
         ArrayList funList = new ArrayList();

         for(int i = 0; i < functions.length; ++i) {
            try {
               FunctionVO[] e = getFunctionVOS(functions[i]);

               for(int j = 0; e != null && j < e.length; ++j) {
                  e[j].setOriFormula(functions[i]);
                  funList.add(e[j]);
               }
            } catch (Exception var6) {
               throw var6;
            }
         }

         if(funList.size() > 0) {
            funvos = (FunctionVO[])funList.toArray(new FunctionVO[0]);
         }

         return funvos;
      } else {
         return null;
      }
   }
}
